#! /usr/bin/python
# -*- coding=utf-8 -*-

"""
    This file is part of Gnome 3 background slideshow.

    Gnome 3 background slideshow is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Gnome 3 background slideshow is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Gnome 3 background slideshow.  If not, see <http://www.gnu.org/licenses/>.
"""

from gi.repository import Gtk
from informations import *

class TrayIcon(Gtk.StatusIcon):
   def __init__(self,applet):
      Gtk.StatusIcon.__init__(self)
      self._applet = applet
      self._list_commands = []
      self.set_tooltip_text(FULL_APP_NAME)
      self.set_from_pixbuf(Gtk.IconTheme.get_default().load_icon("background", Gtk.IconSize.SMALL_TOOLBAR, Gtk.IconLookupFlags.USE_BUILTIN))
      self._context_menu = self._build_context_menu()
      self.connect('popup-menu', self._popup_menu)
      self.connect('activate', lambda w:self._applet.next_picture())
   def enable_list_options(self):
      for i in self._list_commands:
         i.set_sensitive(True)
   def disable_list_options(self):
      for i in self._list_commands:
         i.set_sensitive(False)
   def _build_context_menu(self):
      res = Gtk.Menu()
      item = Gtk.ImageMenuItem.new_from_stock(Gtk.STOCK_PREFERENCES, None)
      item.connect('activate', lambda w:self._applet.show_properties())
      res.add(item)
      item = Gtk.ImageMenuItem.new_from_stock(Gtk.STOCK_MEDIA_NEXT, None)
      item.connect('activate', lambda w:self._applet.next_picture())
      res.add(item)
      self._list_commands.append(item)
      item = Gtk.ImageMenuItem.new_from_stock(Gtk.STOCK_EDIT, None)
      item.connect('activate', lambda w:self._applet.edit_list())
      item.set_label(_("EDIT_PICTURES_LIST"))
      res.add(item)
      self._list_commands.append(item)
      res.add(Gtk.SeparatorMenuItem())
      item = Gtk.ImageMenuItem.new_from_stock(Gtk.STOCK_ABOUT, None)
      item.connect('activate', lambda w:self._applet.show_about())
      res.add(item)
      res.add(Gtk.SeparatorMenuItem())
      res.add(Gtk.SeparatorMenuItem())
      item = Gtk.ImageMenuItem.new_from_stock(Gtk.STOCK_QUIT, None)
      item.connect('activate', lambda w:self._applet.quit())
      res.add(item)
      res.show_all()
      return res
   def _popup_menu(self, widget, button, timestamp):
      self._context_menu.popup(None, None, Gtk.StatusIcon.position_menu, self, button, timestamp)
      
