#! /usr/bin/python
# -*- coding=utf-8 -*-

"""
    This file is part of Gnome 3 background slideshow.

    Gnome 3 background slideshow is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Gnome 3 background slideshow is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Gnome 3 background slideshow.  If not, see <http://www.gnu.org/licenses/>.
"""

from gi.repository import GdkPixbuf
import os

class PixbufCache(object):
   def __init__(self):
      self._pixbufs = {}
      self._files_mtime = {}
      self._queue = []
   def get(self, filename, width, height):
      mtime = os.path.getmtime(filename)
      if filename in self._files_mtime and mtime!=self._files_mtime[filename] and filename in self._pixbufs:
         del self._pixbufs[filename]
      self._files_mtime[filename] = mtime
      if not filename in self._pixbufs:
         self._pixbufs[filename] = {}
      if not width in self._pixbufs[filename]:
         self._pixbufs[filename][width] = {}
      if not height in self._pixbufs[filename][width]:
         try:
            self._pixbufs[filename][width][height] = GdkPixbuf.Pixbuf.new_from_file_at_size(filename, width, height)
            self._queue.append((filename, width, height))
         except:
            self._pixbufs[filename][width][height] = None
      while len(self._queue)>100:
         f, w, h = self._queue[0]
         if f in self._pixbufs and w in self._pixbufs[f] and h in self._pixbufs[f][w]:
            del self._pixbufs[f][w][h]
         del self._queue[0]
      return self._pixbufs[filename][width][height]
