#! /usr/bin/python
# -*- coding=utf-8 -*-

"""
    This file is part of Gnome 3 background slideshow.

    Gnome 3 background slideshow is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Gnome 3 background slideshow is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Gnome 3 background slideshow.  If not, see <http://www.gnu.org/licenses/>.
"""

import thread

class ThreadedVariable(object):
   def __init__(self, value):
      self._value = value
      self._lock = thread.allocate_lock()
   def get(self):
      self._lock.acquire()
      res = self._value
      self._lock.release()
      return res
   def set(self, value):
      self._lock.acquire()
      self._value = value
      self._lock.release()

class ThreadedList(ThreadedVariable):
   def __init__(self, value=[]):
      ThreadedVariable.__init__(self, value)
   def append(self, item):
      self._lock.acquire()
      self._value.append(item)
      self._lock.release()
   def __len__(self):
      self._lock.acquire()
      res = len(self._value)
      self._lock.release()
      return res
   def __getitem__(self, index):
      self._lock.acquire()
      res = self._value[index]
      self._lock.release()
      return res
   def __delitem__(self, index):
      self._lock.acquire()
      del self._value[index]
      self._lock.release()
