#!/usr/bin/env python

from distutils.core import setup
import os
from Gnome3BackgroundSlideShow.informations import *

def walk_share_files(res,path,files):
   if ".svn" in path:
      return
   l=[]
   for i in files:
      if os.path.isfile(os.path.join(path,i)):
         if i[-1]!='~' and i[-4:]!='.bak':
            l.append(os.path.join(path,i))
   if l:
      res.append(('/usr/share'+path[5:],l))

def list_share_files():
   res=[]
   os.path.walk('share',walk_share_files,res)
   return res

def walk_etc_files(res,path,files):
   if ".svn" in path:
      return
   l=[]
   for i in files:
      if os.path.isfile(os.path.join(path,i)):
         if i[-1]!='~' and i[-4:]!='.bak':
            l.append(os.path.join(path,i))
   if l:
      res.append(('/etc'+path[3:],l))

def list_etc_files():
   res=[]
   os.path.walk('etc',walk_etc_files,res)
   return res

def build_translations():
   for i in os.listdir("translations"):
      if i.endswith(".pot") or i.endswith(".po"):
         if i.endswith(".pot"):
            lang = "en"
         else:
            lang = i[:-3]
         src_file = os.path.join("translations", i)
         dest_file = os.path.join("share", "locale", lang, "LC_MESSAGES", UNIX_APP_NAME+".mo")
         os.system("mkdir -p \"%s\""%os.path.split(dest_file)[0])
         os.system("msgfmt \"%s\" -o \"%s\""%(src_file, dest_file))

build_translations()

setup(name=UNIX_APP_NAME,
   version=VERSION,
   author='Gwendal Le Bihan',
   author_email='gwendal.lebihan.dev@gmail.com',
   maintainer='Gwendal Le Bihan',
   maintainer_email='gwendal.lebihan.dev@gmail.com',
   description=FULL_APP_NAME,
   scripts=['gnome3-background-slideshow'],
   packages=['Gnome3BackgroundSlideShow', 'Gnome3BackgroundSlideShow.PicturesListEditor'],
   data_files=list_share_files()+list_etc_files()
   )
